rem ################ϐݒ################
set INFO_AVS=%TEMP_DIR%\information.avs
set X264_TC_FILE=%TEMP_DIR%\x264.tc

rem ################擾################
echo ^>^>%ANALYZE_ANNOUNCE%
echo;

rem rbg[g̏o
.\MediaInfo.exe --Inform=Audio;%%BitRate%% --LogFile=%TEMP_INFO% %INPUT_AUDIO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set /a INPUT_A_BIT_RATE=%%i /1000 1>nul 2>&1

rem TvO[g̏o
.\MediaInfo.exe --Inform=Audio;%%SamplingRate%% --LogFile=%TEMP_INFO% %INPUT_AUDIO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set /a SAMPLERATE=%%i

.\MediaInfo.exe --Inform=Audio;%%Channels%% --LogFile=%TEMP_INFO% %INPUT_FILE_PATH%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set AUDIO_CHANNELS=%%i

if not "%ENC_MODE%"=="IMAGEMUX" goto movie_mux_mode

if /i "%INPUT_AUDIO_TYPE%"==".mp3" set MAKEFLV=f

rem 摜ƉMUX
.\MediaInfo.exe --Inform=Audio;%%PlayTime%% --LogFile=%TEMP_INFO% %INPUT_AUDIO%>nul
for /f "delims=." %%i in (%TEMP_INFO%) do set TOTAL_TIME=%%i
if "%TOTAL_TIME%"=="" (
    echo ^>^>%ANALYZE_ERROR%
    echo;
    call quit.bat
)
echo PlayTime       : %TOTAL_TIME%ms


.\MediaInfo.exe --Inform=General;%%FileSize%% %INPUT_AUDIO%> %TEMP_INFO%
for /f %%i in (%TEMP_INFO%) do set /a AUDIO_SIZE=%%i
echo %INPUT_AUDIO_TYPE% File Size : %AUDIO_SIZE% byte

echo Sampling Rate  : %SAMPLERATE% Hz


if /i "%INPUT_AUDIO_TYPE%"==".wav" goto audio_info_end

if exist "%ProgramFiles(x86)%" (
    if exist %WINDIR%\SysWOW64\vp6vfw.dll (
      set VP6VFW_CHECK=t
    )
) else (
    if exist %WINDIR%\system32\vp6vfw.dll (
      set VP6VFW_CHECK=t
    )
)

if "%SAMPLERATE%"=="44100" (
  set A_RATE_MP3=t
  goto audio_info_end
) 
if "%SAMPLERATE%"=="22000" (
  set A_RATE_MP3=t
  goto audio_info_end
) 

:audio_info_end 
set FPS=10

(
    echo ImageSource^(%INPUT_VIDEO%,end=1,fps=%FPS%^)
    echo _premium_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_PREMIUM%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _normal_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_NORMAL%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _youtube_partner_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_YOUTUBE_PARTNER%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _youtube_normal_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_YOUTUBE_NORMAL%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _max_size_limit = String^(Floor^(Float^(%DEFAULT_SIZE_PREMIUM%^) * 1024 * 1024^)^)
    echo;
    echo WriteFileStart^("premium_bitrate.txt","_premium_bitrate",append = false^)
    echo WriteFileStart^("normal_bitrate.txt","_normal_bitrate",append = false^)
    echo WriteFileStart^("youtube_partner_bitrate.txt","_youtube_partner_bitrate",append = false^)
    echo WriteFileStart^("youtube_normal_bitrate.txt","_youtube_normal_bitrate",append = false^)
    echo WriteFileStart^("premium_file_size_limit.txt","_normal_bitrate",append = false^)
    echo;
    echo return last
)> %INFO_AVS%

.\wavi.exe %INFO_AVS% 1>nul 2>&1

for /f "delims=" %%i in (%TEMP_DIR%\premium_bitrate.txt) do set /a P_TEMP_BITRATE=%%i>nul
for /f "delims=" %%i in (%TEMP_DIR%\normal_bitrate.txt) do set /a I_TEMP_BITRATE=%%i>nul
for /f "delims=" %%i in (%TEMP_DIR%\youtube_partner_bitrate.txt) do set /a Y_P_TEMP_BITRATE=%%i>nul
for /f "delims=" %%i in (%TEMP_DIR%\youtube_normal_bitrate.txt) do set /a Y_I_TEMP_BITRATE=%%i>nul
for /f "delims=" %%i in (%TEMP_DIR%\premium_file_size_limit.txt) do set /a MAX_SIZE_LIMIT=%%i>nul

set /a TOTAL_TIME_DSECOND=%TOTAL_TIME%/100

.\MediaInfo.exe --Inform=Image;%%Width%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set IN_WIDTH=%%i
echo Width          : %IN_WIDTH%pixels
.\MediaInfo.exe --Inform=Image;%%Height%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set IN_HEIGHT=%%i
echo Height         : %IN_HEIGHT%pixels

rem 𑜓x4̔{ǂ̔
set /a WIDTH_REM=%IN_WIDTH% %% 4
set /a HEIGHT_REM=%IN_HEIGHT% %% 4

if not "%WIDTH_REM%"=="0" (
  set IMAGE_SIZE_ERROR=t
)
if not "%HEIGHT_REM%"=="0" (
  set IMAGE_SIZE_ERROR=t
)

set /a IN_WIDTH_ODD=%IN_WIDTH% %% 2
set /a IN_HEIGHT_ODD=%IN_HEIGHT% %% 2
set /a OUT_WIDTH=%IN_WIDTH%

if not "%DEFAULT_HEIGHT%"=="" set /a OUT_HEIGHT=%DEFAULT_HEIGHT%

if not "%DEFAULT_HEIGHT%"=="" (
    set /a OUT_HEIGHT=%DEFAULT_HEIGHT%
    goto image_info_end
)

set /a OUT_HEIGHT_TEMP=%DEFAULT_WIDTH% * %IN_HEIGHT% / %IN_WIDTH%
set /a OUT_HEIGHT_ODD=%OUT_HEIGHT_TEMP% %% 2
set /a OUT_HEIGHT=%OUT_HEIGHT_TEMP% - %OUT_HEIGHT_ODD%

:image_info_end
echo Decoder        : %DECODER%
echo;
echo ^>^>%ANALYZE_END%
echo;
echo;

rem ################ݒ̎################
call setting_question.bat

rem ################GRƊJn################
echo;
echo %HORIZON%
echo;
echo;
echo ^>^>%VIDEO_ENC_ANNOUNCE%
echo;

if "%MAKEFLV%"=="y" (
    call FLV4enc.bat
    call shut.bat
)


rem ################fGR[h################
rem AVSt@C쐬
(
    echo ImageSource^(%INPUT_VIDEO%,end=%TOTAL_TIME_DSECOND%,fps=%FPS%^)
    if "%IN_WIDTH_ODD%"=="1" echo Crop^(0,0,-1,0^)
    if "%IN_HEIGHT_ODD%"=="1" echo Crop^(0,0,0,-1^)
    if "%SETTING2%"=="noresize" (
        echo # no resize
    ) else (
        if "%RESIZER%"=="" set RESIZER=Spline16Resize
        echo %RESIZER%^(%WIDTH%,%HEIGHT%^)
        echo;
    )
    echo ConvertToYV12^(^)
    echo;
    echo return last
)> %VIDEO_AVS%

echo ^>^>%AVS_END%
echo;

rem 264ɃGR[h

rem Ppass
echo ^>^>Ppassځ`
echo;
if "%FULL_RANGE%"=="off" (
    set RANGE=tv
) else if "%FULL_RANGE%"=="on" (
    set RANGE=pc
) else (
    set RANGE=auto
)

.\x264.exe --range %RANGE% -I 100 -i 100 --no-scenecut -b 0 -r 1 -f -1:-1 -B %V_BITRATE% --ipratio 1.0 --aq-mode 2 --aq-strength 0.70 -p 1 --stats %TEMP_DIR%\x264_2pass.log --qcomp 0.8 --direct auto --weightp 0 --me dia -m 1 -t 1 --no-fast-pskip --no-dct-decimate --threads 0 --thread-input --colormatrix smpte170m --quiet -o "nul" %VIDEO_AVS%
echo;

rem Qpass
echo ^>^>Qpassځ`
echo;
.\x264.exe --range %RANGE% -I 100 -i 100 --no-scenecut -b 0 -r 1 -f -1:-1 -B %V_BITRATE% --ipratio 1.0 --aq-mode 2 --aq-strength 0.70 -p 2 --stats %TEMP_DIR%\x264_2pass.log --qcomp 0.8 --direct auto --weightp 0 --me dia -m 1 -t 1 --no-fast-pskip --no-dct-decimate --threads 0 --thread-input --colormatrix smpte170m --quiet -o %TEMP_264% %VIDEO_AVS%
echo;

echo ^>^>%VIDEO_ENC_END%
echo;


rem ################GR[h################
echo ^>^>%VIDEO_ENC_END%
echo;

if "%A_BITRATE%"=="0" (
    echo ^>^>%SILENCE_ANNOUNCE%
    echo;
    copy /y mute.m4a %TEMP_DIR%\audio.m4a 1>nul 2>&1
    goto :eof
)

echo ^>^>%AUDIO_ENC_ANNOUNCE%
echo;

if "%INPUT_AUDIO_TYPE%"==".wav" (
  (
    echo WavSource^(%INPUT_AUDIO%^)
    echo;
  )> %AUDIO_AVS%
) else (
  (
    echo LoadPlugin^("DirectShowSource.dll"^)
    echo;
    echo DirectShowSource^(%INPUT_AUDIO%, video = false^)
  )> %AUDIO_AVS%
)  

if "%A_GAIN%"=="0" goto close_audio_avs
(
  echo Normalize^(^)
  echo AmplifydB^(%A_GAIN%^)
)>> %AUDIO_AVS%

:close_audio_avs
(
    echo;
    echo return last
)>> %AUDIO_AVS%

echo ^>^>%WAV_ANNOUNCE%
.\wavi.exe %AUDIO_AVS%  %TEMP_WAV%
echo;

call m4a_enc.bat

goto :eof


rem ƉMUX
:movie_mux_mode
if /i "%INPUT_FILE_TYPE%"==".mp4" (
     set PRESET_S_ENABLE=y
)

rem ̃tH[}bgo
.\MediaInfo.exe --Inform=General;%%Format/String%% --LogFile=%TEMP_INFO% %INPUT_FILE_PATH%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set C_FORMAT=%%i
echo File Format    : %C_FORMAT%
.\MediaInfo.exe --Inform=Video;%%Format%% --LogFile=%TEMP_INFO% %INPUT_FILE_PATH%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set V_FORMAT=%%i
echo Video Format : "%V_Format%"
.\MediaInfo.exe --Inform=Video;%%CodecID/Info%% --LogFile=%TEMP_INFO% %INPUT_FILE_PATH%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set V_CODEC=%%i
if "%V_CODEC%"==""  (
  .\MediaInfo.exe --Inform=Video;%%Codec/Info%% --LogFile=%TEMP_INFO% %INPUT_FILE_PATH%>nul
   for /f "delims=" %%i in (%TEMP_INFO%) do set V_CODEC=%%i
)
if "%V_CODEC%"==""  (
  .\MediaInfo.exe --Inform=Video;%%CodecID%% --LogFile=%TEMP_INFO% %INPUT_FILE_PATH%>nul
   for /f "delims=" %%i in (%TEMP_INFO%) do set V_CODEC=%%i
)
if "%V_CODEC%"==""  (
  .\MediaInfo.exe --Inform=Video;%%Codec%% --LogFile=%TEMP_INFO% %INPUT_FILE_PATH%>nul
   for /f "delims=" %%i in (%TEMP_INFO%) do set V_CODEC=%%i
)
if not "%V_CODEC%"=="" echo Video Codec  : "%V_CODEC%"
.\MediaInfo.exe --Inform=Video;%%BitRate%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set /a S_V_BITRATE=%%i/1000
echo Video Bitrate: %S_V_BITRATE% kbps
.\MediaInfo.exe --Inform=Audio;%%Format%% --LogFile=%TEMP_INFO% %INPUT_AUDIO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set AUDIO_Format=%%i
.\MediaInfo.exe --Inform=Audio;%%Channels%% --LogFile=%TEMP_INFO% %INPUT_AUDIO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set AUDIO_CHANNELS=%%i
if not "%AUDIO_CHANNELS%"=="" echo Audio Channels : %AUDIO_CHANNELS%
.\MediaInfo.exe --Inform=Audio;%%BitRate_Mode%% --LogFile=%TEMP_INFO% %INPUT_AUDIO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set ABITRATE_MODE=%%i
if not "%ABITRATE_MODE%"== "" echo AudioBR Mode : %ABITRATE_MODE%
echo Audio Bitrate: %INPUT_A_BIT_RATE% kbps

rem ̗eʏo
.\MediaInfo.exe --Inform=General;%%FileSize%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set INPUT_FILE_SIZE=%%i
echo FileSize     : %INPUT_FILE_SIZE% byte

rem ĐԂ̏o
.\MediaInfo.exe --Inform=General;%%PlayTime%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul

rem ĐԁErbg[g̐ݒ
for /f "delims=." %%i in (%TEMP_INFO%) do set TOTAL_TIME=%%i
echo PlayTime     : %TOTAL_TIME% ms

rem CFRiŒt[[gjVFRiσt[[gj̔f
.\MediaInfo.exe --Inform=Video;%%FrameRate_Mode%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set FPS_MODE=%%i
if "%FPS_MODE%"=="VFR" goto vfr_info

rem CFR̐ݒ
set VFR=false
.\MediaInfo.exe --Inform=Video;%%FrameRate%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set INPUT_FPS=%%i
if not "%INPUT_FPS%"=="" echo FPS          : %INPUT_FPS% fps^(CFR^)
goto fps_main

rem VFR̐ݒ
:vfr_info
set VFR=true
.\MediaInfo.exe --Inform=Video;%%FrameRate%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set INPUT_FPS=%%i
echo FPS          : %INPUT_FPS%fps^(VFR^)
.\MediaInfo.exe --Inform=Video;%%FrameRate_Minimum%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do echo Minimum FPS  : %%i
.\MediaInfo.exe --Inform=Video;%%FrameRate_Maximum%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do echo Maximum FPS  : %%i

:fps_main
if "%DEFAULT_FPS%"=="" (
    set CHANGE_FPS=false
    set FPS=%INPUT_FPS%
) else (
    set CHANGE_FPS=true
    set FPS=%DEFAULT_FPS%
)

rem 𑜓x̐ݒ
.\MediaInfo.exe --Inform=Video;%%Width%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set IN_WIDTH=%%i
echo Width        : %IN_WIDTH%pixels
.\MediaInfo.exe --Inform=Video;%%Height%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set IN_HEIGHT=%%i
echo Height       : %IN_HEIGHT%pixels

rem 𑜓x4̔{ǂ̔
set /a WIDTH_REM=%IN_WIDTH% %% 4
set /a HEIGHT_REM=%IN_HEIGHT% %% 4

if not "%WIDTH_REM%"=="0" (
  set IMAGE_SIZE_ERROR=t
)
if not "%HEIGHT_REM%"=="0" (
  set IMAGE_SIZE_ERROR=t
)

rem AXyNg
.\MediaInfo.exe --Inform=Video;%%DisplayAspectRatio%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set D_ASPECT=%%i
echo AspectRatio  : %D_ASPECT%
.\MediaInfo.exe --Inform=Video;%%PixelAspectRatio%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set P_ASPECT=%%i

rem C^[[X֘A̐ݒ
:interlace
.\MediaInfo.exe --Inform=Video;%%ScanType%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set SCAN_TYPE=%%i
if not "%SCAN_TYPE%"=="" echo Scan type    : %SCAN_TYPE%
.\MediaInfo.exe --Inform=Video;%%ScanOrder%% --LogFile=%TEMP_INFO% %INPUT_VIDEO%>nul
for /f  %%i in (%TEMP_INFO%) do set SCAN_ORDER=%%i
if not "%SCAN_ORDER%"=="" echo Scan order   : %SCAN_ORDER%

rem IDRt[Ԃ̍őԊuEeʏ̐ݒ
if /i "%DECODER%"=="avi" goto avisource_info
if /i "%DECODER%"=="ffmpeg" goto ffmpegsource_info
if /i "%DECODER%"=="directshow" goto directshowsource_info
if /i "%DECODER%"=="qt" goto qtsource_info

:directshowsource_info
(
    echo LoadPlugin^("DirectShowSource.dll"^)
    echo;
    echo DirectShowSource^(%INPUT_VIDEO%, audio = false^)
)> %INFO_AVS%
goto infoavs

:qtsource_info
(
    echo LoadPlugin^("QTSource.dll"^)
    echo;
    echo QTInput^(%INPUT_VIDEO%, quality = 100, audio = 0^)
)> %INFO_AVS%
goto infoavs

:avisource_info
echo AVISource^(%INPUT_VIDEO%, audio = false^)> %INFO_AVS%
goto infoavs

:ffmpegsource_info
if "%VFR%"=="true" (
    echo;
    echo exporting timecode...
    if exist %X264_TC_FILE% del %X264_TC_FILE%
    .\x264 --preset ultrafast -q 51 -o nul --no-progress --quiet --tcfile-out %X264_TC_FILE% %INPUT_VIDEO% 2>nul
    if exist %X264_TC_FILE% (
        echo done.
        set X264_VFR_ENC=true
        set TEMP_264=%TEMP_DIR%\video.mp4
    ) else (
        echo failed.
        echo ^(encode as cfr^)
    )
)
(
    echo LoadPlugin^("ffms2.dll"^)
    echo;
    echo FFVideoSource^(%INPUT_VIDEO%,cache=false,threads=1^)
)> %INFO_AVS%

:infoavs
(
    echo;
    echo _isyv12 = IsYV12^(^)
    echo _isrgb = IsRGB^(^)
    echo _fps = Framerate^(^)
    if not "%FPS%"=="" (
        echo _keyint = String^(Round^(%FPS%^)^)
    ) else (
        echo _keyint = String^(Round^(_fps^)^)
    )
    echo _premium_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_PREMIUM%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _normal_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_NORMAL%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _youtube_partner_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_YOUTUBE_PARTNER%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _youtube_normal_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_YOUTUBE_NORMAL%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _in_width = String^(Floor^(Float^(%IN_WIDTH%^) * %P_ASPECT%^)^)
    echo _max_size_limit = String^(Floor^(Float^(%DEFAULT_SIZE_PREMIUM%^) * 1024 * 1024^)^)
    echo;
    echo WriteFileStart^("yv12.txt","_isyv12",append = false^)
    echo WriteFileStart^("rgb.txt","_isrgb",append = false^)
    echo WriteFileStart^("fps.txt","_fps",append = false^)
    echo WriteFileStart^("keyint.txt","_keyint",append = false^)
    echo WriteFileStart^("premium_bitrate.txt","_premium_bitrate",append = false^)
    echo WriteFileStart^("normal_bitrate.txt","_normal_bitrate",append = false^)
    echo WriteFileStart^("youtube_partner_bitrate.txt","_youtube_partner_bitrate",append = false^)
    echo WriteFileStart^("youtube_normal_bitrate.txt","_youtube_normal_bitrate",append = false^)
    echo WriteFileStart^("in_width.txt","_in_width",append = false^)
    echo WriteFileStart^("premium_file_size_limit.txt","_normal_bitrate",append = false^)
    echo;
    echo Trim^(0,-1^)
    echo;
    echo return last
)>> %INFO_AVS%

.\wavi.exe %INFO_AVS% 1>nul 2>&1

if not exist "%TEMP_DIR%\yv12.txt" (
  if "%DECODER%"=="ffmpeg" (
    set FFMS_INFO=f
    echo ^>^>ffmpegsource %ANALYZE_ERROR2%
  )
  if "%DECODER%"=="avi" (
    set AVI_INFO=f
    echo ^>^>avi %ANALYZE_ERROR2%
  )
  if "%DECODER%"=="directshow" (
    set DIRECTSHOW_INFO=f
    echo ^>^>directshow %ANALYZE_ERROR2%
  )
  if "%DECODER%"=="qt" (
    set QT_INFO=f
    echo ^>^>QuickTime %ANALYZE_ERROR2%
  )
)

if not exist "%TEMP_DIR%\yv12.txt" (
  if not "%FFMS_INFO%"=="f" (
    set DECODER=ffmpeg
    echo ^>^>%ANALYZE_ERROR3%  
    goto ffmpegsource_info
  )
  if not "%AVI_INFO%"=="f" (
    set DECODER=avi
    echo ^>^>%ANALYZE_ERROR3%  
    goto avisource_info
  )
  if not "%DIRECTSHOW_INFO%"=="f" (
    set DECODER=directshow
    echo ^>^>%ANALYZE_ERROR3%  
    goto directshowsource_info
  )
  if not "%QT_INFO%"=="f" (
    set DECODER=qt
    echo ^>^>%ANALYZE_ERROR3%  
    goto qtsource_info
  )
)

if exist %TEMP_DIR%\yv12.txt (
  for /f "delims=" %%i in (%TEMP_DIR%\yv12.txt) do set YV12=%%i>nul
  for /f "delims=" %%i in (%TEMP_DIR%\rgb.txt) do set RGB=%%i>nul
  for /f "delims=" %%i in (%TEMP_DIR%\keyint.txt) do set /a KEYINT=%%i*10>nul
  for /f "delims=" %%i in (%TEMP_DIR%\premium_bitrate.txt) do set /a P_TEMP_BITRATE=%%i>nul
  for /f "delims=" %%i in (%TEMP_DIR%\normal_bitrate.txt) do set /a I_TEMP_BITRATE=%%i>nul
  for /f "delims=" %%i in (%TEMP_DIR%\youtube_partner_bitrate.txt) do set /a Y_P_TEMP_BITRATE=%%i>nul
  for /f "delims=" %%i in (%TEMP_DIR%\youtube_normal_bitrate.txt) do set /a Y_I_TEMP_BITRATE=%%i>nul
  for /f "delims=" %%i in (%TEMP_DIR%\in_width.txt) do set IN_WIDTH_MOD=%%i>nul
  for /f "delims=" %%i in (%TEMP_DIR%\in_width.txt) do set IN_WIDTH_MOD=%%i>nul
  for /f "delims=" %%i in (%TEMP_DIR%\premium_file_size_limit.txt) do set /a MAX_SIZE_LIMIT=%%i>nul
  for /f "delims=" %%i in (%TEMP_DIR%\fps.txt) do set AVS_FPS=%%i>nul 2>&1
) else (
    goto info_check
)
if "%FPS%"=="" set FPS=%AVS_FPS%

rem o͉𑜓x̐ݒ
set /a IN_WIDTH_ODD=%IN_WIDTH_MOD% %% 2
set /a IN_HEIGHT_ODD=%IN_HEIGHT% %% 2
set /a OUT_WIDTH=%IN_WIDTH_MOD%
if not "%DEFAULT_HEIGHT%"=="" (
    set /a OUT_HEIGHT=%DEFAULT_HEIGHT%
    goto info_check
)
set /a OUT_HEIGHT_TEMP=%DEFAULT_WIDTH% * %IN_HEIGHT% / %IN_WIDTH_MOD%
set /a OUT_HEIGHT_ODD=%OUT_HEIGHT_TEMP% %% 2
set /a OUT_HEIGHT=%OUT_HEIGHT_TEMP% - %OUT_HEIGHT_ODD%

:error_report
(
    if exist "%ProgramFiles(x86)%" (
      echo OS           : Windows XP Vista 7 64 bit
    ) else (
      echo OS           : Windows 2000 XP Vista 7 32 bit
    )
      echo Version      : %TDENC_NAME%%C_VERSION%
      echo %USED_SOFTWARE%
      echo Source Movie : %ORIGINAL_VIDEO%
      echo Source Audio : %ORIGINAL_AUDIO%
      echo File Format  : %C_FORMAT%
      echo Video Format : "%V_Format%"
      echo Video Codec  : "%V_CODEC%"
      echo FPS MODE     : %FPS_MODE%
      echo Audio Format : "%AUDIO_FORMAT%"
      echo AudioBitRate : %INPUT_A_BIT_RATE:~3% kbps
      echo AudioChannels: %AUDIO_CHANNELS%
      echo Sampling rate: %SAMPLERATE% Hz
      echo FileSize     : %INPUT_FILE_SIZE% byte
      echo PlayTime     : %TOTAL_TIME% ms
      if not "%INPUT_FPS%"=="" (
        if "%FPS_MODE%"=="VFR" (
           echo FPS          : %INPUT_FPS% fps^(VFR^)
        ) else (
           echo FPS          : %INPUT_FPS% fps^(CFR^)
        )
      ) else (
         echo FPS          : %AVS_FPS% fps^(CFR^) ^(from Avisynth^)
      )
      echo WidthxHeight : %IN_WIDTH% pixels x %IN_HEIGHT% pixels ^(AspectRatio : %D_ASPECT%^)
      if not "%SCAN_TYPE%"=="" echo Scan type    : %SCAN_TYPE%
      if not "%SCAN_ORDER%"=="" echo Scan order   : %SCAN_ORDER%
      
      echo Decoder      : %DECODER% ^(FFMS=%FFMS_INFO%, AVI=%AVI_INFO%, DIRECTSHOW=%DIRECTSHOW_INFO%, QT=%QT_INFO%^)
)>> %ERROR_REPORT%

:info_check
if "%TOTAL_TIME%"=="" (
    echo ^>^>%ANALYZE_ERROR%
    call quit.bat
)
if "%KEYINT%"=="" (
    echo;
    echo ^>^>%DECODE_ERROR3%
    echo ^>^>%DECODE_ERROR4%
    echo ^>^>%DECODE_ERROR5%
    echo ^>^>%DECODE_ERROR6%
    call quit.bat
)

rem ################ݒ̎################
:mux_mode_question
echo Decoder      : %DECODER%
echo;
echo ^>^>%ANALYZE_END%
echo;
echo;
call setting_question.bat

rem ###############vZbgs################
if /i "%PRETYPE%"=="s" (
  set TEMP_264=%INPUT_VIDEO%
  goto mux_audio_start
)
rem ################GRƊJn################
echo;
echo %HORIZON%
echo;
echo;
echo ^>^>%VIDEO_ENC_ANNOUNCE%
echo;

rem ################fGR[h################
rem AVSt@C쐬
if /i "%RGB%"=="true" (
    if /i "%FULL_RANGE%"=="on" (
        if /i "%COLORMATRIX%"=="BT.709" (
            set AVS_SCALE=matrix^=^"PC.709^"^,
        ) else (
            set AVS_SCALE=matrix^=^"PC.601^"^,
        )
    ) else (
        if /i "%COLORMATRIX%"=="BT.709" (
            set AVS_SCALE=matrix^=^"Rec709^"^,
        ) else (
            set AVS_SCALE=matrix^=^"Rec601^"^,
        )
    )
) else (
    set AVS_SCALE=
)

if /i "%DECODER%"=="avi" goto avisource_video
if /i "%DECODER%"=="ffmpeg" goto ffmpegsource_video
if /i "%DECODER%"=="directshow" goto directshowsource_video
if /i "%DECODER%"=="qt" goto qtsource_video

:directshowsource_video
(
    echo LoadPlugin^("DirectShowSource.dll"^)
    echo;
    if "%VFR%"=="true" (
        echo DirectShowSource^(%INPUT_VIDEO%, audio = false, fps=%INPUT_FPS%, convertfps=true^)
    ) else (
        echo DirectShowSource^(%INPUT_VIDEO%, audio = false, fps=%INPUT_FPS%, convertfps=false^)
    )
)> %VIDEO_AVS%
goto vbr_avs

:qtsource_video
(
    echo LoadPlugin^("QTSource.dll"^)
    echo;
    echo QTInput^(%INPUT_VIDEO%, quality = 100, audio = 0^)
)> %VIDEO_AVS%
goto vbr_avs

:avisource_video
echo AVISource^(%INPUT_VIDEO%, audio = false^)> %VIDEO_AVS%
goto vbr_avs

:ffmpegsource_video
rem echo %INPUT_FILE_TYPE% | findstr /i "mts m2ts">nul
rem if "%ERRORLEVEL%"=="0" (
rem     set SEEKMODE=0
rem     ffmsindex.exe -m lavf -f %INPUT_VIDEO% %TEMP_DIR%\input.ffindex
rem ) else (
    set SEEKMODE=1
    ffmsindex.exe -m default -f %INPUT_VIDEO% %TEMP_DIR%\input.ffindex
rem )
echo;
(
    echo LoadPlugin^("ffms2.dll"^)
    echo;
    echo fps_num = Int^(%FPS% * 1000^)
    if "%VFR%"=="true" (
        echo FFVideoSource^(%INPUT_VIDEO%,cachefile="input.ffindex",seekmode=%SEEKMODE%,threads=1^)
    ) else (
        echo FFVideoSource^(%INPUT_VIDEO%,cachefile="input.ffindex",seekmode=%SEEKMODE%,threads=1,fpsnum=fps_num,fpsden=1000^)
    )
)> %VIDEO_AVS%

:vbr_avs
echo;>> %VIDEO_AVS%
if "%ABITRATE_MODE%"=="VBR" (
    if not "%A_SYNC%"=="n" (
    echo EnsureVBRMP3Sync^(^)>> %VIDEO_AVS%
    )
)
echo;>> %VIDEO_AVS%
if "%SCAN_TYPE%"=="Interlaced" goto interlace
if "%SCAN_TYPE%"=="MBAFF" goto interlace

rem vObVu
if /i "%YV12%"=="true" goto fps_avs

if "%IN_WIDTH_ODD%"=="1" echo Crop^(0,0,-1,0^)>> %VIDEO_AVS%
if "%IN_HEIGHT_ODD%"=="1" echo Crop^(0,0,0,-1^)>> %VIDEO_AVS%

echo ConvertToYV12^(%AVS_SCALE%interlaced=false^)>> %VIDEO_AVS%
echo;>> %VIDEO_AVS%
goto fps_avs

rem C^[[X
:interlace
echo Load_Stdcall_Plugin^("yadif.dll"^)>> %VIDEO_AVS%
if /i "%YV12%"=="true" goto yadif
echo ConvertToYV12^(%AVS_SCALE%interlaced=true^)>> %VIDEO_AVS%
echo;>> %VIDEO_AVS%
:yadif
if "%SCAN_TYPE%"=="MBAFF" (
    echo Yadif^(order=1^)>> %VIDEO_AVS%
    goto fps_avs
)
if "%SCAN_ORDER%"=="Top" (
    echo Yadif^(order=1^)>> %VIDEO_AVS%
    goto fps_avs
)
if "%SCAN_ORDER%"=="Bottom" (
    echo Yadif^(order=0^)>> %VIDEO_AVS%
    goto fps_avs
)
echo Yadif^(order=-1^)>> %VIDEO_AVS%

:fps_avs
(
    echo;
    if "%CHANGE_FPS%"=="true" echo ChangeFPS^(%FPS%^)
    echo;

    if "%RESIZER%"=="" set RESIZER=Spline16Resize
    if not "%IN_WIDTH%"=="%WIDTH%" echo %RESIZER%^(%WIDTH%,last.height^(^)^)
    if not "%IN_HEIGHT%"=="%HEIGHT%" echo %RESIZER%^(last.width^(^),%HEIGHT%^)
    echo;
    echo return last
)>> %VIDEO_AVS%

echo ^>^>%AVS_END%
echo;

call x264_enc.bat

rem ################GR[h################
echo ^>^>%VIDEO_ENC_END%
echo;

if "%A_BITRATE%"=="0" (
    echo ^>^>%SILENCE_ANNOUNCE%
    echo;
    copy /y mute.m4a %TEMP_DIR%\audio.m4a 1>nul 2>&1
    goto :eof
)

:mux_audio_start
echo ^>^>%AUDIO_ENC_ANNOUNCE%
echo;

if "%INPUT_AUDIO_TYPE%"==".wav" (
  (
    echo WavSource^(%INPUT_AUDIO%^)
    echo;
  )> %AUDIO_AVS%
) else (
  (
    echo LoadPlugin^("DirectShowSource.dll"^)
    echo;
    echo DirectShowSource^(%INPUT_AUDIO%, video = false^)
  )> %AUDIO_AVS%
)  

if "%A_GAIN%"=="0" goto close_audio_avs
(
  echo Normalize^(^)
  echo AmplifydB^(%A_GAIN%^)
)>> %AUDIO_AVS%

:close_audio_avs
(
    echo;
    echo return last
)>> %AUDIO_AVS%

echo ^>^>%WAV_ANNOUNCE%
if exist %PROCESS_E_FILE% del %PROCESS_E_FILE%
echo s>%PROCESS_S_FILE%
start /b process.bat 2>nul
.\wavi.exe %AUDIO_AVS% %TEMP_WAV% 1>nul 2>&1

del %PROCESS_S_FILE% 2>nul
:wav_process
ping localhost -n 1 >nul
if not exist %PROCESS_E_FILE% goto wav_process 1>nul 2>&1
del %PROCESS_E_FILE%

call m4a_enc.bat
